local imgui = require 'imgui'
local encoding = require 'encoding'
encoding.default = 'CP1251'
u8 = encoding.UTF8
local game_board = {
    0, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0,
    0, 0, 0, 0,
}
local game = 0 -- 0 - not started, 1 - active, 2 - over
local score = 0
local best = 0
local game_window = imgui.ImBool(false)
function main()
    if not isSampLoaded() and not isSampfuncsLoaded() then return end
    while not isSampAvailable() do wait(100) end
    sampAddChatMessage('2048 {ffffff}by CaJlaT {00ff00}[Loaded]', 0xe2e017)
    while true do
        wait(0)
        if testCheat('2048') then game_window.v = not game_window.v end
        imgui.Process = game_window.v
        if not game_window.v and isPlayerControlLocked() then lockPlayerControl(false) end
    end
end
function imgui.OnDrawFrame()
    local X, Y = getScreenResolution()
    imgui.SetNextWindowSize(imgui.ImVec2(380, 471), imgui.Cond.FirstUseEver)
    imgui.SetNextWindowPos(imgui.ImVec2(X / 2, Y / 2), imgui.Cond.FirstUseEver, imgui.ImVec2(0.5, 0.5))
    imgui.Begin(u8"2048 | by CaJlaT", game_window, imgui.WindowFlags.NoScrollbar + imgui.WindowFlags.NoResize)
    imgui.BeginChild("Score", imgui.ImVec2(105, 60))
        imgui.SetCursorPosX((105-imgui.CalcTextSize('Score: '..score).x)/2)
        imgui.SetCursorPosY((60-imgui.CalcTextSize('Score: '..score).y)/2)
        imgui.Text('Score: '..score)
    imgui.EndChild()
    imgui.SameLine()
    imgui.BeginChild("Best", imgui.ImVec2(105, 60))
        imgui.SetCursorPosX((105-imgui.CalcTextSize('Best: '..best).x)/2)
        imgui.SetCursorPosY((60-imgui.CalcTextSize('Best: '..best).y)/2)
        imgui.Text('Best: '..best)
    imgui.EndChild()
    imgui.BeginChild("game", imgui.ImVec2(363, 364), true)
        if game == 0 then
            if imgui.Button('Start', imgui.ImVec2(-1,-1)) then
                math.randomseed(os.time())  
                game_board[math.random(1, #game_board)] = 2
                game_board[math.random(1, #game_board)] = 2
                score = 0
                game = 1
            end
        elseif game == 1 then
            lockPlayerControl(true)
            for i=1,#game_board do
                if i == 4 or i == 8 or i == 12 or i == 16 then
                    if game_board[i] == 0 then imgui.CustomButton('', imgui.ImVec4(0.2,0.2,0.2,1), imgui.ImVec4(0.2,0.2,0.2,1), imgui.ImVec4(0.2,0.2,0.2,1), imgui.ImVec2(80,80)) end
                    if game_board[i] == 2 then imgui.CustomButton(tostring(game_board[i]), imgui.ImVec4(0.3, 0.3, 0.2, 1), imgui.ImVec4(0.3, 0.3, 0.2, 1), imgui.ImVec4(0.3, 0.3, 0.2, 1), imgui.ImVec2(80,80)) end
                    if game_board[i] == 4 then imgui.CustomButton(tostring(game_board[i]), imgui.ImVec4(0.48, 0.48, 0.25, 1), imgui.ImVec4(0.48, 0.48, 0.25, 1), imgui.ImVec4(0.48, 0.48, 0.25, 1), imgui.ImVec2(80,80)) end
                    if game_board[i] == 8 then imgui.CustomButton(tostring(game_board[i]), imgui.ImVec4(0.64, 0.64, 0.2, 1), imgui.ImVec4(0.64, 0.64, 0.2, 1), imgui.ImVec4(0.64, 0.64, 0.2, 1), imgui.ImVec2(80,80)) end
                    if game_board[i] == 16 then imgui.CustomButton(tostring(game_board[i]), imgui.ImVec4(0.83, 0.63, 0.13, 1), imgui.ImVec4(0.83, 0.63, 0.13, 1), imgui.ImVec4(0.83, 0.63, 0.13, 1), imgui.ImVec2(80,80)) end
                    if game_board[i] == 32 then imgui.CustomButton(tostring(game_board[i]), imgui.ImVec4(1, 0.54, 0.02, 1), imgui.ImVec4(1, 0.54, 0.02, 1), imgui.ImVec4(1, 0.54, 0.02, 1), imgui.ImVec2(80,80)) end
                    if game_board[i] == 64 then imgui.CustomButton(tostring(game_board[i]), imgui.ImVec4(1, 0.37, 0, 1), imgui.ImVec4(1, 0.37, 0, 1), imgui.ImVec4(1, 0.37, 0, 1), imgui.ImVec2(80,80)) end
                    if game_board[i] == 128 then imgui.CustomButton(tostring(game_board[i]), imgui.ImVec4(1, 0.23, 0, 1), imgui.ImVec4(1, 0.23, 0, 1), imgui.ImVec4(1, 0.23, 0, 1), imgui.ImVec2(80,80)) end
                    if game_board[i] == 256 then imgui.CustomButton(tostring(game_board[i]), imgui.ImVec4(1, 0.12, 0, 1), imgui.ImVec4(1, 0.12, 0, 1), imgui.ImVec4(1, 0.12, 0, 1), imgui.ImVec2(80,80)) end
                    if game_board[i] == 512 then imgui.CustomButton(tostring(game_board[i]), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec2(80,80)) end
                    if game_board[i] == 1024 then imgui.CustomButton(tostring(game_board[i]), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec2(80,80)) end
                    if game_board[i] == 2048 then imgui.CustomButton(tostring(game_board[i]), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec2(80,80)) end
                    if game_board[i] == 4096 then imgui.CustomButton(tostring(game_board[i]), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec2(80,80)) end
                    if game_board[i] == 8192 then imgui.CustomButton(tostring(game_board[i]), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec2(80,80)) end
                    if game_board[i] == 16384 then imgui.CustomButton(tostring(game_board[i]), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec2(80,80)) end
                    if game_board[i] == 32768 then imgui.CustomButton(tostring(game_board[i]), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec2(80,80)) end
                else
                    if game_board[i] == 0 then imgui.CustomButton('', imgui.ImVec4(0.2,0.2,0.2,1), imgui.ImVec4(0.2,0.2,0.2,1), imgui.ImVec4(0.2,0.2,0.2,1), imgui.ImVec2(80,80)) end
                    if game_board[i] == 2 then imgui.CustomButton(tostring(game_board[i]), imgui.ImVec4(0.3, 0.3, 0.2, 1), imgui.ImVec4(0.3, 0.3, 0.2, 1), imgui.ImVec4(0.3, 0.3, 0.2, 1), imgui.ImVec2(80,80)) end
                    if game_board[i] == 4 then imgui.CustomButton(tostring(game_board[i]), imgui.ImVec4(0.48, 0.48, 0.25, 1), imgui.ImVec4(0.48, 0.48, 0.25, 1), imgui.ImVec4(0.48, 0.48, 0.25, 1), imgui.ImVec2(80,80)) end
                    if game_board[i] == 8 then imgui.CustomButton(tostring(game_board[i]), imgui.ImVec4(0.64, 0.64, 0.2, 1), imgui.ImVec4(0.64, 0.64, 0.2, 1), imgui.ImVec4(0.64, 0.64, 0.2, 1), imgui.ImVec2(80,80)) end
                    if game_board[i] == 16 then imgui.CustomButton(tostring(game_board[i]), imgui.ImVec4(0.83, 0.63, 0.13, 1), imgui.ImVec4(0.83, 0.63, 0.13, 1), imgui.ImVec4(0.83, 0.63, 0.13, 1), imgui.ImVec2(80,80)) end
                    if game_board[i] == 32 then imgui.CustomButton(tostring(game_board[i]), imgui.ImVec4(1, 0.54, 0.02, 1), imgui.ImVec4(1, 0.54, 0.02, 1), imgui.ImVec4(1, 0.54, 0.02, 1), imgui.ImVec2(80,80)) end
                    if game_board[i] == 64 then imgui.CustomButton(tostring(game_board[i]), imgui.ImVec4(1, 0.37, 0, 1), imgui.ImVec4(1, 0.37, 0, 1), imgui.ImVec4(1, 0.37, 0, 1), imgui.ImVec2(80,80)) end
                    if game_board[i] == 128 then imgui.CustomButton(tostring(game_board[i]), imgui.ImVec4(1, 0.23, 0, 1), imgui.ImVec4(1, 0.23, 0, 1), imgui.ImVec4(1, 0.23, 0, 1), imgui.ImVec2(80,80)) end
                    if game_board[i] == 256 then imgui.CustomButton(tostring(game_board[i]), imgui.ImVec4(1, 0.12, 0, 1), imgui.ImVec4(1, 0.12, 0, 1), imgui.ImVec4(1, 0.12, 0, 1), imgui.ImVec2(80,80)) end
                    if game_board[i] == 512 then imgui.CustomButton(tostring(game_board[i]), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec2(80,80)) end
                    if game_board[i] == 1024 then imgui.CustomButton(tostring(game_board[i]), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec2(80,80)) end
                    if game_board[i] == 2048 then imgui.CustomButton(tostring(game_board[i]), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec2(80,80)) end
                    if game_board[i] == 4096 then imgui.CustomButton(tostring(game_board[i]), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec2(80,80)) end
                    if game_board[i] == 8192 then imgui.CustomButton(tostring(game_board[i]), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec2(80,80)) end
                    if game_board[i] == 16384 then imgui.CustomButton(tostring(game_board[i]), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec2(80,80)) end
                    if game_board[i] == 32768 then imgui.CustomButton(tostring(game_board[i]), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec4(1, 0, 0, 1), imgui.ImVec2(80,80)) end
                    imgui.SameLine()
                end
            end
            if isKeyJustPressed(38) then -- up
                for i = 16, 5, -1 do
                    local loop_next = i-4
                    if game_board[i] ~= 0 then
                        if game_board[loop_next] == game_board[i] then
                            game_board[loop_next] = game_board[loop_next] + game_board[i]
                            score = score + game_board[i]
                            game_board[i] = 0
                        end
                        if game_board[loop_next] == 0 then
                            game_board[loop_next] = game_board[i]
                            game_board[i] = 0
                        end
                    end
                end 
                --     ;)
                for i = 16, 5, -1 do
                    local loop_next = i-4
                    if game_board[i] ~= 0 then
                        if game_board[loop_next] == game_board[i] then
                            game_board[loop_next] = game_board[loop_next] + game_board[i]
                            score = score + game_board[i]
                            game_board[i] = 0
                        end
                        if game_board[loop_next] == 0 then
                            game_board[loop_next] = game_board[i]
                            game_board[i] = 0
                        end
                    end
                end
                local random = {}
                for i=1,#game_board do
                    if game_board[i] == 0 then table.insert(random, i) end
                end
                if #random == 0 then game = 2 
                elseif #random >= 2 then
                    math.randomseed(os.time())
                    game_board[random[math.random(1, #random)]] = 2
                    game_board[random[math.random(1, #random)]] = 2
                else
                    math.randomseed(os.time())
                    game_board[random[math.random(1, #random)]] = 2
                end
            end
            if isKeyJustPressed(40) then -- down
                for i=1,12 do
                    local loop_next = i+4
                    if loop_next > 16 then return end
                    if game_board[loop_next] == game_board[i] then
                        score = score + game_board[i]
                        game_board[loop_next] = game_board[loop_next] + game_board[i]
                        game_board[i] = 0
                    end
                    if game_board[loop_next] == 0 then
                        game_board[loop_next] = game_board[i]
                        game_board[i] = 0
                    end
                end
                --     ;)
                for i=1,12 do
                    local loop_next = i+4
                    if loop_next > 16 then return end
                    if game_board[loop_next] == game_board[i] then
                        score = score + game_board[i]
                        game_board[loop_next] = game_board[loop_next] + game_board[i]
                        game_board[i] = 0
                    end
                    if game_board[loop_next] == 0 then
                        game_board[loop_next] = game_board[i]
                        game_board[i] = 0
                    end
                end
                local random = {}
                for i=1,#game_board do
                    if game_board[i] == 0 then table.insert(random, i) end
                end
                if #random == 0 then game = 2 
                elseif #random >= 2 then
                    math.randomseed(os.time())
                    game_board[random[math.random(1, #random)]] = 2
                    game_board[random[math.random(1, #random)]] = 2
                else
                    math.randomseed(os.time())
                    game_board[random[math.random(1, #random)]] = 2
                end
            end
            if isKeyJustPressed(37) then -- left
                for i=16,1, -1 do
                    local loop_next = i-1
                    if loop_next ~= 12 and loop_next ~= 8 and loop_next ~= 4 then
                        if game_board[i] ~= 0 then
                            if game_board[loop_next] == game_board[i] then
                                game_board[loop_next] = game_board[loop_next] + game_board[i]
                                score = score + game_board[i]
                                game_board[i] = 0
                            end
                            if game_board[loop_next] == 0 then
                                game_board[loop_next] = game_board[i]
                                game_board[i] = 0
                            end
                        end
                    end
                end
                --     ;)
                for i=16,1, -1 do
                    local loop_next = i-1
                    if loop_next ~= 12 and loop_next ~= 8 and loop_next ~= 4 then
                        if game_board[i] ~= 0 then
                            if game_board[loop_next] == game_board[i] then
                                game_board[loop_next] = game_board[loop_next] + game_board[i]
                                score = score + game_board[i]
                                game_board[i] = 0
                            end
                            if game_board[loop_next] == 0 then
                                game_board[loop_next] = game_board[i]
                                game_board[i] = 0
                            end
                        end
                    end
                end
                local random = {}
                for i=1,#game_board do
                    if game_board[i] == 0 then table.insert(random, i) end
                end
                if #random == 0 then game = 2 
                elseif #random >= 2 then
                    math.randomseed(os.time())
                    game_board[random[math.random(1, #random)]] = 2
                    game_board[random[math.random(1, #random)]] = 2
                else
                    math.randomseed(os.time())
                    game_board[random[math.random(1, #random)]] = 2
                end
            end
            if isKeyJustPressed(39) then -- right
                for i=1,15 do
                    local loop_next = i+1
                    if loop_next ~= 13 and loop_next ~= 9 and loop_next ~= 5 then
                        if game_board[i] ~= 0 then
                            if game_board[loop_next] == game_board[i] then
                                game_board[loop_next] = game_board[loop_next] + game_board[i]
                                score = score + game_board[i]
                                game_board[i] = 0
                            end
                            if game_board[loop_next] == 0 then
                                game_board[loop_next] = game_board[i]
                                game_board[i] = 0
                            end
                        end
                    end
                end
                --     ;)
                for i=1,15 do
                    local loop_next = i+1
                    if loop_next ~= 13 and loop_next ~= 9 and loop_next ~= 5 then
                        if game_board[i] ~= 0 then
                            if game_board[loop_next] == game_board[i] then
                                game_board[loop_next] = game_board[loop_next] + game_board[i]
                                score = score + game_board[i]
                                game_board[i] = 0
                            end
                            if game_board[loop_next] == 0 then
                                game_board[loop_next] = game_board[i]
                                game_board[i] = 0
                            end
                        end
                    end
                end
                local random = {}
                for i=1,#game_board do
                    if game_board[i] == 0 then table.insert(random, i) end
                end
                if #random == 0 then game = 2 
                elseif #random >= 2 then
                    math.randomseed(os.time())
                    game_board[random[math.random(1, #random)]] = 2
                    game_board[random[math.random(1, #random)]] = 2
                else
                    math.randomseed(os.time())
                    game_board[random[math.random(1, #random)]] = 2
                end
            end
        elseif game == 2 then
            if imgui.Button('Game Over\n\n\n   Restart',imgui.ImVec2(-1,-1)) then
                game_board = {
                    0, 0, 0, 0,
                    0, 0, 0, 0,
                    0, 0, 0, 0,
                    0, 0, 0, 0,
                }
                math.randomseed(os.time())
                game_board[math.random(1, #game_board)] = 2
                game_board[math.random(1, #game_board)] = 2
                if best < score then best = score end
                score = 0
                game = 1
            end
        end
    imgui.EndChild()
    imgui.End()
end
function imgui.CustomButton(gg, color, colorHovered, colorActive, size)
    local clr = imgui.Col
    imgui.PushStyleColor(clr.Button, color)
    imgui.PushStyleColor(clr.ButtonHovered, colorHovered)
    imgui.PushStyleColor(clr.ButtonActive, colorActive)
    if not size then size = imgui.ImVec2(0, 0) end
    local result = imgui.Button(gg, size)
    imgui.PopStyleColor(3)
    return result
end
function style()
    imgui.SwitchContext()
    local style = imgui.GetStyle()
    local colors = style.Colors
    local clr = imgui.Col
    local ImVec4 = imgui.ImVec4
    style.WindowPadding = imgui.ImVec2(8, 8)
    style.WindowRounding = 10
    style.ChildWindowRounding = 10
    style.FramePadding = imgui.ImVec2(4, 4)
    style.FrameRounding = 6.0
    style.ItemSpacing = imgui.ImVec2(9.0, 9.0)
    style.ItemInnerSpacing = imgui.ImVec2(9.0, 3.0)
    style.IndentSpacing = 21
    style.ScrollbarSize = 6.0
    style.ScrollbarRounding = 13
    style.GrabMinSize = 17.0
    style.GrabRounding = 16.0
    style.WindowTitleAlign = imgui.ImVec2(0.5, 0.5)
    style.ButtonTextAlign = imgui.ImVec2(0.5, 0.5)

    colors[clr.Text]                   = ImVec4(0.00, 0.00, 0.00, 1)
    colors[clr.WindowBg]               = ImVec4(0.82, 0.75, 0.75, 0.94)
    colors[clr.ChildWindowBg]          = ImVec4(0.376, 0.322, 0.322, 0.592)
    colors[clr.Button]                 = ImVec4(0.15, 0.10, 0.10, 0.40)
    colors[clr.ButtonHovered]          = ImVec4(0.15, 0.11, 0.11, 0.55)
    colors[clr.ButtonActive]           = ImVec4(0.15, 0.11, 0.11, 0.70)
end
style()